;************************************
;SketchAVoice - dynamically associates a synthesized vowels-based 'voice' with the act of drawing
;************************************

XIncludeFile "PortAudio.pb"

Global DaCounter.l = 0 ;for tracking filter values from previous iterations, for use in the filter model

Global InitF1.d
Global InitF2.d
Global InitF3.d
Global InitB1.d
Global InitB2.d
Global InitB3.d

Global FinalF1.d
Global FinalF2.d
Global FinalF3.d
Global FinalB1.d
Global FinalB2.d
Global FinalB3.d

Global TheF1.d
Global TheF2.d
Global TheF3.d
Global TheB1.d
Global TheB2.d
Global TheB3.d

;filter resonator 1 coefficients
Global ACoeff.d
Global BCoeff.d
Global CCoeff.d
;filter resonator 2 coefficients
Global ACoeff2.d
Global BCoeff2.d
Global  CCoeff2.d
;filter resonator 3 coefficients
Define ACoeff3.d
Define BCoeff3.d
Define CCoeff3.d

Global Wye.d ;stores current value of filter calculation
Global WyeOld.d ;stores previous value of filter calculation
Global WyeRealOld.d ;stores previous to previouls value of filter calculation

Global Wye2.d
Global Wye2Old.d
Global Wye2RealOld.d

Global Wye3.d
Global Wye3Old.d
Global Wye3RealOld.d

Global RollOffCounter.l=0 ;for tracking release of sound when mouse up in drawing area
Global RollOnCounter.l=0 ;for tracking attack of sound when mouse down in drawing area
Global MouseUpFlag.l = 0

Global Phase.d = 0
Global Phase_Add.d
Global SampleRate.d = 44100
Global Pi2.d = 6.28318530717958
Global Pi.d = 3.14159265358979
Global Freq.d 

Global YPos.d ;for interpolating between the coefficients of vowels

Global NewFreq.d
Global OldFreq.d = 0
Global StoreOldFreq.d = 0
Global ChangeFreqFlag.l = 0
Global s.l = 0


Global StartTime.l
Global ElpasedTime.l

Global Took.l=0 ;for toggling on/off timer thread posting events to update drawing window


;variables for setting the scale*********
Global Dim ChromaticScale.s(11)
ChromaticScale(0) = "C"
ChromaticScale(1) = "C#"
ChromaticScale(2) = "D"
ChromaticScale(3) = "D#"
ChromaticScale(4) = "E"
ChromaticScale(5) = "F"
ChromaticScale(6) = "F#"
ChromaticScale(7) = "G"
ChromaticScale(8) = "G#"
ChromaticScale(9) = "A"
ChromaticScale(10) = "A#"
ChromaticScale(11) = "B"

Global Dim MajorScale.l(5)
MajorScale(0) = 2
MajorScale(1) = 2
MajorScale(2) = 1
MajorScale(3) = 2
MajorScale(4) = 2
MajorScale(5) = 2

Global Dim MinorScale.l(5)
MinorScale(0) = 2
MinorScale(1) = 1
MinorScale(2) = 2
MinorScale(3) = 2
MinorScale(4) = 1
MinorScale(5) = 2

Global Dim PentaMajorScale.l(3)
PentaMajorScale(0) = 2
PentaMajorScale(1) = 2
PentaMajorScale(2) = 3
PentaMajorScale(3) = 2

Global Dim PentaMinorScale.l(3)
PentaMinorScale(0) = 3
PentaMinorScale(1) = 2
PentaMinorScale(2) = 2
PentaMinorScale(3) = 3

Global Dim ScaleNotesPos.l(6)
Global Dim PentaNotesPos.l(4)

Global Key.s ;user selected note key
Global KeyPos.l ;index of selected key in chromatic scale
;**************************************************


;*********timer thread stuff*************
Enumeration #PB_Event_FirstCustomValue
    #EventProcessing
  EndEnumeration
  Global tid_1 ;timer thread for playback of recording
  Global ai.l = 0 ;for triggering update in waitwindowevent every millisecond
;********end timer thread definitions**************  
  
  Global Pos.l = 0 ;for incrementing record in linked list mylist
  Global NewList mylist.s()  ;for recording drawing movements
  Global NewList gridrefreshlist.s() ;for keeping a snapshot of drawing when setting and unsetting grid
 
  Global SpeedFactor.d = 1 ;determines playback speed

  Phase_Add = Freq/SampleRate
  
  Procedure Thread(Value)
  Repeat
  Delay(1)
    If took = 0
        ai = ai+1
        PostEvent(#EventProcessing)
    EndIf  
  ForEver
  EndProcedure


Procedure Error(err)
  Debug Pa_GetErrorText(err)
  MessageRequester("", PeekS(Pa_GetErrorText(err)))
  End
EndProcedure

err = Pa_Initialize()
If err <> #paNoError
  Error(err)
EndIf  
  
  
Procedure.d Saw(Phh.d)
  Define Q.d 
  If Phh < 0.5
   Q = 0.35 * Sin(Phh)
  Else
   Q = (0.35 * Sin(1 - Phh)) + 0.5
  EndIf
ProcedureReturn Q
EndProcedure


Procedure.s GetExePath()
  Protected Path.s = GetPathPart(ProgramFilename())
  If Path = GetTemporaryDirectory()
    Path = GetCurrentDirectory()
  EndIf
  ProcedureReturn Path
EndProcedure

Procedure SaveTheFile()
  StandardFile$ = GetExePath() + "SketchAVoice"  ; set initial file+path to display
  Pattern$ = "SketchAVoice (*.sav)|*.sav"
  Pattern = 0    ; use the first pattern
  File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
  If File$ And ListSize(mylist())>0
    If UCase(Right(File$, 4)) <> ".SAV"
      File$ = File$ + ".sav"
    EndIf  
      CreateFile(200, File$)
        For f = 0 To ListSize(mylist())-1
          SelectElement(mylist(), f)
          String.s = mylist()
	      WriteStringN(200, String)
	      Next f
	    CloseFile(200)
  Else
    MessageRequester("Informer", "Your SketchAVoice file is not saved!", 0) 
  EndIf
EndProcedure


Procedure OpenTheFile()
    
    ;display dialog box
  StandardFile$ = GetExePath()   ; set initial file+path to display
  Pattern$ = "SketchAVoice (*.sav)|*.sav"
  Pattern = 0 
  File$ = OpenFileRequester("Please choose file to open", StandardFile$, Pattern$, Pattern)
  If File$
        If ReadFile(300, File$)
          ClearList(mylist())
          ClearList(gridrefreshlist())  
          While Eof(300) = 0
            AddElement(mylist()) : mylist() = ReadString(300)
            AddElement(gridrefreshlist()) : gridrefreshlist() = mylist()
      	  Wend
    	  CloseFile(300)
    	  EndIf
    	
    	      If StartDrawing(CanvasOutput(99))
    	            Box(0, 0, 240, 200, $ffffff)
    	                 For f = 0 To ListSize(mylist())-1
                       SelectElement(mylist(), f)
                       x = ValD(StringField(mylist(),1,";"))
                       y = ValD(StringField(mylist(),2,";"))
                       Circle(x, y, 2, RGB($00,$00,$FF)) 
                       Next f 
                  StopDrawing()
            EndIf
                  
            If GetGadgetState(97) =  1 ;if recording, stop record
                SetGadgetState(97,0)
                SetGadgetText(97, "record")
                DisableGadget(98,0)
            EndIf
            SetGadgetState(110,0) ;untick grid, if it is currently on    
            ;ClearList(gridrefreshlist())    
                	
  EndIf
EndProcedure

Procedure ShowAboutWindow()
  
  Protected AboutWindow, myEditorGadget, CloseButton 
  Protected Text$
  Protected Quit
  
  AboutWindow = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 620, 373, "SketchAVoice Help", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  If AboutWindow
    
    myEditorGadget = EditorGadget(#PB_Any, 5, 5, 610, 360, #PB_Editor_ReadOnly)
    
Text$ = Chr($d) + "*Left click in the rectangular window area of the application and drag to draw an image." + Chr($d)
Text$ + Chr($d) + "*As you draw, a synthesized voice will sound following the drawing movement. Vowel sounds change along the Y axis" 
Text$ + Chr($d) +  "sound and the pitch along the X axis. Releasing and pressing left mouse button stops and starts sound respectively." + Chr($d)
Text$ + Chr($d) + "*Choose 'Major', 'Minor' or 'Pentatonic' for the pitch change to follow a scale, and choose the Note of the scale." + Chr($d)
Text$ + Chr($d) + "*Press 'clear' button to wipe the image from the drawing area." + Chr($d)
Text$ + Chr($d) + "*To record your drawing movement, press 'Record' button, perform drawing and press the button again to finish." + Chr($d)
Text$ + Chr($d) + "*Play back your recording by pressing 'Play' button. Use slider to adjust speed of playback." + Chr($d)
Text$ + Chr($d) + "*If you have chosen 'Major', 'Minor' or 'Pentatonic' settings, you can tick the Grid checkbox during drawing/recording."
Text$ + Chr($d) + "The Grid shows position of notes of the scale in the drawing space, to aid your composition." + Chr($d)
Text$ + Chr($d) + "*To save your recording, choose 'File>Save'. To load a recording, choose 'File>Open'." + Chr($d)
Text$ + Chr($d) + "*The application synthesizes the voice sound by feeding a sawtooth wave into a set of three parallel narrow band-pass"
Text$ + Chr($d) +  "filters, each tuned to a resonant frequency (formant), and combining the outputs. Choosing 'Voice>Type1' or"
Text$ + Chr($d) + "'Voice>Type2' option from the menu simply alters the bandwidth and frequency tunings of each of the filters, which"
Text$ + Chr($d) + "results in the vowel sweeps sounding a little different." + Chr($d)

    SetGadgetText(myEditorGadget, Text$)
    
    Repeat 
      
      Select WaitWindowEvent()
          
        Case #PB_Event_Gadget :      If EventGadget()=CloseButton : Break : EndIf
        Case #PB_Event_CloseWindow : If EventWindow()=AboutWindow : Break : EndIf 
          
      EndSelect
      
    ForEver
    
    CloseWindow(AboutWindow)
    
  EndIf
  
EndProcedure

Procedure RefreshGrid()
  
  If GetGadgetState(110) =  1
              If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                If StartDrawing(CanvasOutput(99))
                        Box(0, 0, 240, 200, $ffffff)
                        For f = 0 To 240 Step 10
                          LineXY(f,0,f,200, 	RGB(192,192,192))
                        Next f
                        For f = 0 To 240 Step 70
                          LineXY(f,0,f,200, 	RGB(128,0,0))
                        Next f
                        
                        For f = 0 To ListSize(gridrefreshlist())-1
                        SelectElement(gridrefreshlist(), f)
                        x = ValD(StringField(gridrefreshlist(),1,";"))
                        y = ValD(StringField(gridrefreshlist(),2,";"))
                        Circle(x, y, 2, RGB($00,$00,$FF)) 
                        Next f  

                        StopDrawing() 
                    EndIf
              EndIf 
                  
              If GetGadgetState(107)=1
                If StartDrawing(CanvasOutput(99))
                            Box(0, 0, 240, 200, $ffffff)
                            For f = 0 To 240 Step 14
                              LineXY(f,0,f,200, 	RGB(192,192,192))
                            Next f
                            For f = 0 To 240 Step 70
                              LineXY(f,0,f,200, 	RGB(128,0,0))
                            Next f
                            
                            For f = 0 To ListSize(gridrefreshlist())-1
                            SelectElement(gridrefreshlist(), f)
                            x = ValD(StringField(gridrefreshlist(),1,";"))
                            y = ValD(StringField(gridrefreshlist(),2,";"))
                            Circle(x, y, 2, RGB($00,$00,$FF)) 
                            Next f 
                            
                            StopDrawing() 
                      EndIf
               EndIf   
                  
EndIf
  
EndProcedure 


Procedure ReferenceArray()

    Key = GetGadgetText(106)
          For z = 0 To ArraySize(ChromaticScale())
            If ChromaticScale(z) = Key
              KeyPos = z
            EndIf
          Next z 
          
          If (GetGadgetState(107)<>1) 
            ScaleNotesPos(0) = KeyPos
          Else
            PentaNotesPos(0) = KeyPos
          EndIf  
          
    If GetGadgetState(103)=1        
          For z = 0 To ArraySize(MajorScale())
            KeyPos = KeyPos + MajorScale(z)
            If KeyPos>11
              KeyPos = KeyPos - 12
            EndIf
            ScaleNotesPos(z+1) = KeyPos
          Next z  
    EndIf  
        
    If GetGadgetState(104)=1        
          For z = 0 To ArraySize(MinorScale())
            KeyPos = KeyPos + MinorScale(z)
            If KeyPos>11
              KeyPos = KeyPos - 12
            EndIf
            ScaleNotesPos(z+1) = KeyPos
          Next z  
    EndIf  
        
        
    If GetGadgetState(107)=1        
          For z = 0 To ArraySize(PentaMajorScale())
            KeyPos = KeyPos + PentaMajorScale(z)
            If KeyPos>11
              KeyPos = KeyPos - 12
            EndIf
            PentaNotesPos(z+1) = KeyPos
          Next z  
    EndIf     
        
           
    If GetGadgetState(107)<>1 
      SortArray(ScaleNotesPos(), #PB_Sort_Ascending)
    Else
      SortArray(PentaNotesPos(), #PB_Sort_Ascending)
    EndIf  
    
        
EndProcedure  
  


ProcedureC PaStreamCallback(*in, *output.Float, frameCount, *timeInfo.PaStreamCallbackTimeInfo, statusFlags, *userData)
   

      For I = 1 To frameCount
        
                  If ChangeFreqFlag = 1
                    s = s + 1
                    Phase_Add = (StoreOldFreq + ((NewFreq - StoreOldFreq)*s/2000))/SampleRate
                    If s>= 2000
                    ChangeFreqFlag = 0
                    s = 0
                    EndIf  
                  Else
                    Phase_Add = Freq/SampleRate
                  EndIf

    Define TheOutput.d
    Define In.d
      
      In = Sin(Pi2*Saw(Phase)) 
    
    If DaCounter < 4
      DaCounter = DaCounter + 1
    EndIf
    
    If DaCounter < 2
               ;filter 1
                Wye = ACoeff * (0.5 * In)
                ;filter 2
                Wye2 = ACoeff2 * (0.5 * In)
                ;filter 3
                Wye3 = ACoeff3 * (0.5 * In)
              ElseIf DaCounter < 3
                ;filter 1
               WyeRealOld = Wye
               Wye = ACoeff * (0.5 * In) + BCoeff * Wye
               WyeOld = Wye
               ;filter 2
               Wye2RealOld = Wye2
               Wye2 = ACoeff2 * (0.5 * In) + BCoeff2 * Wye2
               Wye2Old = Wye2
               ;filter 3
               Wye3RealOld = Wye3
               Wye3 = ACoeff3 * (0.5 * In) + BCoeff3 * Wye3
               Wye3Old = Wye3
             ElseIf DaCounter >= 3
               ;filter 1
               Wye = ACoeff * (0.5 * In) + BCoeff * WyeOld + CCoeff * WyeRealOld
               WyeRealOld = WyeOld
               WyeOld = Wye
               ;filter 2
               Wye2 = ACoeff2 * (0.5 * In) + BCoeff2 * Wye2Old + CCoeff2 * Wye2RealOld
               Wye2RealOld = Wye2Old
               Wye2Old = Wye2
               ;filter 3
               Wye3 = ACoeff3 * (0.5 * In) + BCoeff3 * Wye3Old + CCoeff3 * Wye3RealOld
               Wye3RealOld = Wye3Old
               Wye3Old = Wye3
             EndIf
            
             TheOutput = (Wye - Wye2 + Wye3)/3
    
             
             If MouseUpFlag = 1
               If RollOffCounter<=3999 ;adjust this value for increasing or decreasing decay of sound when mouse up in drawing area
                 RollOffCounter = RollOffCounter + 1
                 TheOutput = TheOutput*((4000-RollOffCounter)/4000)
               Else
                 TheOutput = 0
               EndIf
             EndIf
             
             If MouseUpFlag = 0
               If RollOnCounter<=999 ;adjust this value for increasing or decreasing attack of sound when mouse down in drawing area
                 RollOnCounter = RollOnCounter + 1
                 TheOutput = TheOutput*((RollOnCounter)/1000)
               EndIf
             EndIf
             
                   
    PokeF(*output, TheOutput)  
            
    Phase = Phase + Phase_Add
    If Phase > 1
      Phase = Phase - 1 
    EndIf  
    *output+4
  Next
 
EndProcedure

Define op.PaStreamParameters
op\channelCount = 1
op\device = Pa_GetDefaultOutputDevice()
op\sampleFormat = #paFloat32
op\suggestedLatency = 75/1000

err = Pa_OpenStream(@Stream, #Null, @op, SampleRate, #paframesperbufferunspecified, #paNoFlag, @PaStreamCallback(), 0)
If err <> #paNoError : Error(err) : EndIf


If OpenWindow(0, 0, 0, 380, 240, "SketchAVoice", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
    If CreateMenu(0, WindowID(0))    
      MenuTitle("File")
        MenuItem(1, "Open")
        MenuItem(2, "Save")
      MenuTitle("Voice") 
        MenuItem(3, "Type 1")
        MenuItem(4, "Type 2")  
      MenuTitle("?")
      MenuItem(5, "About")
      MenuItem(6, "Help")
      SetMenuItemState(0, 3, 1)
    EndIf   

  ButtonGadget(97, 280, 27.5, 60, 20, "record",  #PB_Button_Toggle)
  ButtonGadget(98, 280, 50, 60, 20, "play",  #PB_Button_Toggle)
  ButtonGadget(108, 280, 5, 60, 20, "clear")
  CanvasGadget(99, 10, 10, 240, 200) 
  TrackBarGadget(100, 275, 70, 75, 20, 10, 50)
  CheckBoxGadget(110, 300, 90, 60, 20, "Grid")
  ;DisableGadget(110,1) ;this does not seem to work, so did a work-around, it is disabled if one tries to click on it when voice is 'unrestricted'
 
  OptionGadget(101, 265, 125, 80, 20, "Unrestricted")
  OptionGadget(103, 265, 145, 45, 20, "Major") 
  OptionGadget(104, 265, 165, 45, 20, "Minor") 
  OptionGadget(107, 265, 185, 100, 20, "Pentatonic") 
  SetGadgetState(101, 1) 
  FrameGadget(105, 255,  110, 115, 100, "Scale")
  TextGadget(109, 350, 30, 20, 20, "")
  
  ComboBoxGadget(106, 315, 155, 45, 20)
  AddGadgetItem(106,0,"C")
  AddGadgetItem(106,1,"C#")
    AddGadgetItem(106,2,"D")
    AddGadgetItem(106,3,"D#")
      AddGadgetItem(106,4,"E")
  AddGadgetItem(106,5,"F")
    AddGadgetItem(106,6,"F#")
  AddGadgetItem(106,7,"G")
      AddGadgetItem(106,8,"G#")
  AddGadgetItem(106,9,"A")
    AddGadgetItem(106,10,"A#")
  AddGadgetItem(106,11,"B")
  
  SetGadgetState(106,0)
  DisableGadget(106,1)
  

  tid_1 = CreateThread(@Thread(), 0)
  Pa_StartStream(stream)
  
    Repeat
      Event = WaitWindowEvent()
          
      If Event = #PB_Event_Gadget And EventGadget() =99 
        If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(99, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
          If GetGadgetState(98) <> 1 
              x = GetGadgetAttribute(99, #PB_Canvas_MouseX)
              y = GetGadgetAttribute(99, #PB_Canvas_MouseY)
              MouseUpFlag = 0
              RollOffCounter = 0
              If x<=0
                x = 0
              EndIf
              If x>=240
                x = 240
              EndIf
              If y<=0
                y = 0
              EndIf
              If y>=200
                y = 200
              EndIf
              
              
              AddElement(gridrefreshlist()) : gridrefreshlist() = StrD(x) + ";" + StrD(y)
              

              If GetGadgetState(97) = 1
                ElapsedTime = ElapsedMilliseconds()-StartTime
                AddElement(mylist()) : mylist() = StrD(x) + ";" + StrD(y) + ";" + Str(MouseUpFlag) + ";" + StrD(ElapsedTime)
              EndIf
              
              
              If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                Quotient.l = Int(x/10) ;Calculated as: Quotient.l = Int(x/(240/((ArraySize(MajorScale())+2)*3.3333)))
                ThePos.l = Mod(Quotient, 7)
                RefArrVal.l = ScaleNotesPos(ThePos)
                SetGadgetText(109, ChromaticScale(RefArrVal))
                Freq = 51.914 * Pow(2, RefArrVal/12)
                
                  If ThePos = 0
                    Freq = Freq * Pow(2, Round((x/72), #PB_Round_Nearest))
                  Else
                    Freq = Freq * Pow(2, Int(x/72))
                  EndIf  

              EndIf 
                
                
                     If GetGadgetState(107)=1 
                        Quotient.l = Int(x/14) 
                        ThePos.l = Mod(Quotient, 5)
                        RefArrVal.l = PentaNotesPos(ThePos)
                        SetGadgetText(109, ChromaticScale(RefArrVal))
                        Freq = 51.914 * Pow(2, RefArrVal/12)
                        
                          If ThePos = 0
                            Freq = Freq * Pow(2, Round((x/72), #PB_Round_Nearest))
                          Else
                            Freq = Freq * Pow(2, Int(x/72))
                          EndIf  

                      EndIf    
                
            If GetGadgetState(101)=1  
            Freq = (x+10)*2.5 ;unrestricted frequency movement
            EndIf
                     
            NewFreq = Freq
            If OldFreq<>0
              If NewFreq<>OldFreq
                ChangeFreqFlag = 1
                StoreOldFreq = OldFreq
              EndIf
            EndIf
            OldFreq = Freq
            

            ;**********************************
            If GetMenuItemState(0, 3) = 1 
                If y>= 0 And y<=50
                  InitF1 = 310
                  InitF2 = 2020
                  InitF3 = 2960
                  InitB1 = 45
                  InitB2 = 200
                  InitB3 = 400
                  FinalF1 = 620
                  FinalF2 = 1660
                  FinalF3 = 2430
                  FinalB1 = 70
                  FinalB2 = 150
                  FinalB3 = 320
                  YPos = 1-((50-y)/50)
                ElseIf y>50 And y <=100
                  InitF1 = 620
                  InitF2 = 1660
                  InitF3 = 2430
                  InitB1 = 70
                  InitB2 = 150
                  InitB3 = 320
                  FinalF1 = 550
                  FinalF2 = 750
                  FinalF3 = 2500
                  FinalB1 = 100
                  FinalB2 = 100
                  FinalB3 = 70
                  YPos = 1-((100-y)/50)
                ElseIf y>100 And y <=150
                  InitF1 = 550
                  InitF2 = 750
                  InitF3 = 2500
                  InitB1 = 100
                  InitB2 = 100
                  InitB3 = 70
                  FinalF1 = 325
                  FinalF2 = 700
                  FinalF3 = 2700
                  FinalB1 = 50
                  FinalB2 = 60
                  FinalB3 = 170
                  YPos = 1-((150-y)/50)
                ElseIf y>150 And y <=200
                  InitF1 = 325
                  InitF2 = 700
                  InitF3 = 2700
                  InitB1 = 50
                  InitB2 = 60
                  InitB3 = 170 
                  FinalF1 = 800
                  FinalF2 = 1150
                  FinalF3 = 2900
                  FinalB1 = 80
                  FinalB2 = 90
                  FinalB3 = 120
                  YPos = 1-((200-y)/50)
                EndIf
            
             EndIf   
                
                
              If GetMenuItemState(0, 4) = 1   
                 If y>= 0 And y<=50
                  InitF1 = 400
                  InitF2 = 1880
                  InitF3 = 2500
                  InitB1 = 70
                  InitB2 = 100
                  InitB3 = 200
                  FinalF1 = 290
                  FinalF2 = 2070
                  FinalF3 = 2960
                  FinalB1 = 60
                  FinalB2 = 200
                  FinalB3 = 400
                  YPos = 1-((50-y)/50)
                ElseIf y>50 And y <=100
                  InitF1 = 290
                  InitF2 = 2070
                  InitF3 = 2960
                  InitB1 = 60
                  InitB2 = 200
                  InitB3 = 400
      		        FinalF1 = 620
              		FinalF2 = 1660
              		FinalF3 = 2430
              		FinalB1 = 70
              		FinalB2 = 150
              		FinalB3 = 320
                  YPos = 1-((100-y)/50)
                ElseIf y>100 And y <=150
      		        InitF1 = 620
              		InitF2 = 1660
              		InitF3 = 2430
              		InitB1 = 70
              		InitB2 = 150
              		InitB3 = 320
      		        FinalF1 = 320
             		  FinalF2 = 900
              		FinalF3 = 2200
              		FinalB1 = 65
              		FinalB2 = 110
             		  FinalB3 = 140
                  YPos = 1-((150-y)/50)
                ElseIf y>150 And y <=200
		              InitF1 = 320
              		InitF2 = 900
              		InitF3 = 2200
              		InitB1 = 65
              		InitB2 = 110
              		InitB3 = 140
                  FinalF1 = 700
                  FinalF2 = 1220
                  FinalF3 = 2600
                  FinalB1 = 130
                  FinalB2 = 70
                  FinalB3 = 160
                  YPos = 1-((200-y)/50)
                EndIf
                
              EndIf 

                

              TheF1 = InitF1 + yPos*(FinalF1 - InitF1)
              TheF2 = InitF2 + yPos*(FinalF2 - InitF2)
              TheF3 = InitF3 + yPos*(FinalF3 - InitF3)
              TheB1 = InitB1 + yPos*(FinalB1 - InitB1)
              TheB2 = InitB2 + yPos*(FinalB2 - InitB2)
              TheB3 = InitB3 + yPos*(FinalB3 - InitB3)
              
              CCoeff = -1 * Exp(-2 * Pi * TheB1 / SampleRate)
              BCoeff = (2 * Exp(-1 * Pi * TheB1 / SampleRate)) * Cos(2 * Pi * TheF1 / SampleRate)
              ACoeff = 1 - CCoeff - BCoeff
              CCoeff2 = -1 * Exp(-2 * Pi * TheB2 / SampleRate)
              BCoeff2 = (2 * Exp(-1 * Pi * TheB2 / SampleRate)) * Cos(2 * Pi * TheF2 / SampleRate)
              ACoeff2 = 1 - CCoeff2 - BCoeff2
              CCoeff3 = -1 * Exp(-2 * Pi * TheB3 / SampleRate)
              BCoeff3 = (2 * Exp(-1 * Pi * TheB3 / SampleRate)) * Cos(2 * Pi * TheF3 / SampleRate)
              ACoeff3 = 1 - CCoeff3 - BCoeff3 
              
              If StartDrawing(CanvasOutput(99))
              Circle(x, y, 2, RGB($00,$00,$FF))  
              StopDrawing()
            EndIf
            
           EndIf 
        EndIf
              If EventType() = #PB_EventType_LeftButtonUp
                MouseUpFlag = 1
                RollOnCounter = 0
                ChangeFreqFlag = 0
                OldFreq = 0
                s = 0
                
                      If GetGadgetState(97) = 1
                       ElapsedTime = ElapsedMilliseconds()-StartTime
                       AddElement(mylist()) : mylist() = StrD(x) + ";" + StrD(y) + ";" + Str(MouseUpFlag) + ";" + StrD(ElapsedTime)
                      EndIf
                
              SetGadgetText(109, "")  
              EndIf
      EndIf  
      

      
       If Event = #PB_Event_Gadget And EventGadget() = 97 
            If GetGadgetState(97) = 1
                If StartDrawing(CanvasOutput(99))
                  Box(0, 0, 240, 200, $ffffff)
                  StopDrawing()
                EndIf
                SetGadgetText(97, "recording")
                TextGadget(109, 350, 30, 20, 20, "")
                ClearList(gridrefreshlist())
              StartTime = ElapsedMilliseconds() 
              ClearList(mylist())
              DisableGadget(98,1)
              
                                  If GetGadgetState(110) =  1
                                        If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                                              If StartDrawing(CanvasOutput(99))
                                                  For f = 0 To 240 Step 10
                                                    LineXY(f,0,f,200, 	RGB(192,192,192))
                                                  Next f
                                                  For f = 0 To 240 Step 70
                                                    LineXY(f,0,f,200, 	RGB(128,0,0))
                                                  Next f
                          
                                                  StopDrawing() 
                                              EndIf
                                        EndIf 
                                            
                                        If GetGadgetState(107)=1
                                                If StartDrawing(CanvasOutput(99))
                                                      For f = 0 To 240 Step 14
                                                        LineXY(f,0,f,200, 	RGB(192,192,192))
                                                      Next f
                                                      For f = 0 To 240 Step 70
                                                        LineXY(f,0,f,200, 	RGB(128,0,0))
                                                      Next f
                                                      
                                                      StopDrawing() 
                                                EndIf
                                         EndIf   
                                            
                          	      EndIf
              
            Else
                SetGadgetText(97, "record")
                DisableGadget(98,0)
            EndIf 
       EndIf  
      
       
       
       If Event = #PB_Event_Gadget And EventGadget() = 98 
         If GetGadgetState(98) = 1
            SetGadgetText(98, "playing")
                If StartDrawing(CanvasOutput(99))
                  Box(0, 0, 240, 200, $ffffff)
                  StopDrawing()
                EndIf
                
                
                MouseUpFlag = 1
                RollOnCounter = 0
                ChangeFreqFlag = 0
                OldFreq = 0
                s = 0
                
            ai = 0
            Pos = 0
            took = 0
          SetGadgetState(110,0)
          DisableGadget(110,1)
          Else
            SetGadgetText(98, "play")
            If IsThread(tid_1)
              took = 1
                    EndIf 
                    
                MouseUpFlag = 1
                RollOnCounter = 0
                ChangeFreqFlag = 0
                OldFreq = 0
                s = 0
                    
                DisableGadget(110,0)    
          EndIf 
       EndIf 
       
       
       
        If Event = #PB_Event_Gadget And EventGadget() = 108
                If StartDrawing(CanvasOutput(99))
                  TextGadget(109, 350, 30, 20, 20, "")
                  Box(0, 0, 240, 200, $ffffff)
                  StopDrawing()
                EndIf
                ClearList(gridrefreshlist())
                
                            If GetGadgetState(110) =  1
                                    If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                                          If StartDrawing(CanvasOutput(99))
                                              For f = 0 To 240 Step 10
                                                LineXY(f,0,f,200, 	RGB(192,192,192))
                                              Next f
                                              For f = 0 To 240 Step 70
                                                LineXY(f,0,f,200, 	RGB(128,0,0))
                                              Next f
                      
                                              StopDrawing() 
                                          EndIf
                            EndIf 
                                        
                                    If GetGadgetState(107)=1
                                            If StartDrawing(CanvasOutput(99))
                                                  For f = 0 To 240 Step 14
                                                    LineXY(f,0,f,200, 	RGB(192,192,192))
                                                  Next f
                                                  For f = 0 To 240 Step 70
                                                    LineXY(f,0,f,200, 	RGB(128,0,0))
                                                  Next f
                                                  
                                                  StopDrawing() 
                                            EndIf
                                     EndIf   
                                        
                      	    EndIf
                  
        EndIf       
       
       
       If Event = #PB_Event_Gadget And EventGadget() = 100
             SpeedFactor = GetGadgetState(100)/10
       EndIf 
           
       If Event = #PB_Event_Gadget And EventGadget() = 103
         ReferenceArray()
         If GetGadgetState(98)<>1
           DisableGadget(110,0)
         EndIf  
         RefreshGrid()
         DisableGadget(106,0)
       EndIf 
           
       If Event = #PB_Event_Gadget And EventGadget() = 104
         ReferenceArray()
         If GetGadgetState(98)<>1
           DisableGadget(110,0)
         EndIf  
         RefreshGrid()
         DisableGadget(106,0)
       EndIf  
           
       If Event = #PB_Event_Gadget And EventGadget() = 106
             ReferenceArray()
       EndIf  
           
       If Event = #PB_Event_Gadget And EventGadget() = 107
         ReferenceArray()
         If GetGadgetState(98)<>1
           DisableGadget(110,0)
         EndIf  
         RefreshGrid()
         DisableGadget(106,0)
       EndIf  
       
       
       If Event = #PB_Event_Gadget And EventGadget() = 110
         If GetGadgetState(101) = 1
           SetGadgetState(110,0)
           DisableGadget(110,1)
         EndIf  
       EndIf  
       

        If Event = #PB_Event_Gadget And EventGadget() = 101
          SetGadgetState(110,0)
          DisableGadget(110,1)
          DisableGadget(106,1)
          TextGadget(109, 350, 30, 20, 20, "")
                  If GetGadgetState(98)<>1
                      If StartDrawing(CanvasOutput(99))
                        Box(0, 0, 240, 200, $ffffff)
                        For f = 0 To ListSize(gridrefreshlist())-1
                        SelectElement(gridrefreshlist(), f)
                        x = ValD(StringField(gridrefreshlist(),1,";"))
                        y = ValD(StringField(gridrefreshlist(),2,";"))
                        Circle(x, y, 2, RGB($00,$00,$FF)) 
                        Next f 
                      StopDrawing() 
                      EndIf
                  EndIf 
       EndIf      
           
       
       
       If Event = #PB_Event_Gadget And EventGadget() = 110
         If GetGadgetState(110) =  1
              If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                    If StartDrawing(CanvasOutput(99))
                        For f = 0 To 240 Step 10
                          LineXY(f,0,f,200, 	RGB(192,192,192))
                        Next f
                        For f = 0 To 240 Step 70
                          LineXY(f,0,f,200, 	RGB(128,0,0))
                        Next f
                        
                        For f = 0 To ListSize(gridrefreshlist())-1
                        SelectElement(gridrefreshlist(), f)
                        x = ValD(StringField(gridrefreshlist(),1,";"))
                        y = ValD(StringField(gridrefreshlist(),2,";"))
                        Circle(x, y, 2, RGB($00,$00,$FF)) 
                        Next f  

                        StopDrawing() 
                    EndIf
              EndIf 
                  
              If GetGadgetState(107)=1
                      If StartDrawing(CanvasOutput(99))
                            For f = 0 To 240 Step 14
                              LineXY(f,0,f,200, 	RGB(192,192,192))
                            Next f
                            For f = 0 To 240 Step 70
                              LineXY(f,0,f,200, 	RGB(128,0,0))
                            Next f
                            
                            For f = 0 To ListSize(gridrefreshlist())-1
                            SelectElement(gridrefreshlist(), f)
                            x = ValD(StringField(gridrefreshlist(),1,";"))
                            y = ValD(StringField(gridrefreshlist(),2,";"))
                            Circle(x, y, 2, RGB($00,$00,$FF)) 
                            Next f 
                            
                            StopDrawing() 
                      EndIf
               EndIf   
                  
         Else
                If StartDrawing(CanvasOutput(99))
                   Box(0, 0, 240, 200, $ffffff)
                   For f = 0 To ListSize(gridrefreshlist())-1
                   SelectElement(gridrefreshlist(), f)
                   x = ValD(StringField(gridrefreshlist(),1,";"))
                   y = ValD(StringField(gridrefreshlist(),2,";"))
                   Circle(x, y, 2, RGB($00,$00,$FF)) 
                    Next f 
                  StopDrawing()
                EndIf
         EndIf  
       EndIf  
       
       
       If Event = #PB_Event_Menu
           ;let us stop the play, If it is playing
  
           If GetGadgetState(98) =  1 
           SetGadgetState(98,0)
           SetGadgetText(98, "play")
        
                If IsThread(tid_1)
                   took = 1
                EndIf 
                            
                MouseUpFlag = 1
                RollOnCounter = 0
                ChangeFreqFlag = 0
                OldFreq = 0
                s = 0
                DisableGadget(110,0)
            EndIf
         
         Select EventMenu()
           Case 1: OpenTheFile()  
           Case 2: SaveTheFile()
             
           Case 3
            If GetMenuItemState(0, 4) = 1  
            SetMenuItemState(0, 3, 1) 
            SetMenuItemState(0, 4, 0) 
            EndIf
            
           Case 4
            If GetMenuItemState(0, 3) = 1  
            SetMenuItemState(0, 4, 1) 
            SetMenuItemState(0, 3, 0) 
            EndIf
            
           Case 5 
             MessageRequester("About", "SketchAVoice v1.01 " + Chr(169) + " Jim Singh" + Chr(13) + "Make your drawings truly sing!")
           Case 6
             ShowAboutWindow()
         EndSelect
       EndIf
        
        
       If Event =  #EventProcessing
         If pos < ListSize(mylist())
           SelectElement(mylist(), Pos)
                If ai> ValD(StringField(mylist(),4,";"))/SpeedFactor 
                  pos = pos + 1
                      If ValD(StringField(mylist(),3,";"))<1
                        MouseUpFlag = 0
                        
                      x = ValD(StringField(mylist(),1,";"))
                      y = ValD(StringField(mylist(),2,";"))
                      RollOffCounter = 0
          
                      If GetGadgetState(103)=1 Or GetGadgetState(104)=1
                        Quotient.l = Int(x/10) ;Calculated as: Quotient.l = Int(x/(240/((ArraySize(MajorScale())+2)*3.3333)))
                        ThePos.l = Mod(Quotient, 7)
                        RefArrVal.l = ScaleNotesPos(ThePos)
                        SetGadgetText(109, ChromaticScale(RefArrVal))
                        Freq = 51.914 * Pow(2, RefArrVal/12)
                        
                          If ThePos = 0
                            Freq = Freq * Pow(2, Round((x/72), #PB_Round_Nearest))
                          Else
                            Freq = Freq * Pow(2, Int(x/72))
                          EndIf  

                      EndIf  
                      
                      
                     If GetGadgetState(107)=1 
                        Quotient.l = Int(x/14) 
                        ThePos.l = Mod(Quotient, 5)
                        RefArrVal.l = PentaNotesPos(ThePos)
                        SetGadgetText(109, ChromaticScale(RefArrVal))
                        Freq = 51.914 * Pow(2, RefArrVal/12)
                        
                          If ThePos = 0
                            Freq = Freq * Pow(2, Round((x/72), #PB_Round_Nearest))
                          Else
                            Freq = Freq * Pow(2, Int(x/72))
                          EndIf  

                     EndIf  
                        
                        
                     If GetGadgetState(101)=1  
                     Freq = (x+10)*2.5 ;unrestricted
                     EndIf   
                      
               
                      NewFreq = Freq
                      If OldFreq<>0
                        If NewFreq<>OldFreq
                          ChangeFreqFlag = 1
                          StoreOldFreq = OldFreq
                        EndIf
                      EndIf
                      OldFreq = Freq
                      
              If GetMenuItemState(0, 3) = 1 
                If y>= 0 And y<=50
                  InitF1 = 310
                  InitF2 = 2020
                  InitF3 = 2960
                  InitB1 = 45
                  InitB2 = 200
                  InitB3 = 400
                  FinalF1 = 620
                  FinalF2 = 1660
                  FinalF3 = 2430
                  FinalB1 = 70
                  FinalB2 = 150
                  FinalB3 = 320
                  YPos = 1-((50-y)/50)
                ElseIf y>50 And y <=100
                  InitF1 = 620
                  InitF2 = 1660
                  InitF3 = 2430
                  InitB1 = 70
                  InitB2 = 150
                  InitB3 = 320
                  FinalF1 = 550
                  FinalF2 = 750
                  FinalF3 = 2500
                  FinalB1 = 100
                  FinalB2 = 100
                  FinalB3 = 70
                  YPos = 1-((100-y)/50)
                ElseIf y>100 And y <=150
                  InitF1 = 550
                  InitF2 = 750
                  InitF3 = 2500
                  InitB1 = 100
                  InitB2 = 100
                  InitB3 = 70
                  FinalF1 = 325
                  FinalF2 = 700
                  FinalF3 = 2700
                  FinalB1 = 50
                  FinalB2 = 60
                  FinalB3 = 170
                  YPos = 1-((150-y)/50)
                ElseIf y>150 And y <=200
                  InitF1 = 325
                  InitF2 = 700
                  InitF3 = 2700
                  InitB1 = 50
                  InitB2 = 60
                  InitB3 = 170 
                  FinalF1 = 800
                  FinalF2 = 1150
                  FinalF3 = 2900
                  FinalB1 = 80
                  FinalB2 = 90
                  FinalB3 = 120
                  YPos = 1-((200-y)/50)
                EndIf
            
             EndIf   
                
                
              If GetMenuItemState(0, 4) = 1   
                 If y>= 0 And y<=50
                  InitF1 = 400
                  InitF2 = 1880
                  InitF3 = 2500
                  InitB1 = 70
                  InitB2 = 100
                  InitB3 = 200
                  FinalF1 = 290
                  FinalF2 = 2070
                  FinalF3 = 2960
                  FinalB1 = 60
                  FinalB2 = 200
                  FinalB3 = 400
                  YPos = 1-((50-y)/50)
                ElseIf y>50 And y <=100
                  InitF1 = 290
                  InitF2 = 2070
                  InitF3 = 2960
                  InitB1 = 60
                  InitB2 = 200
                  InitB3 = 400
      		        FinalF1 = 620
              		FinalF2 = 1660
              		FinalF3 = 2430
              		FinalB1 = 70
              		FinalB2 = 150
              		FinalB3 = 320
                  YPos = 1-((100-y)/50)
                ElseIf y>100 And y <=150
      		        InitF1 = 620
              		InitF2 = 1660
              		InitF3 = 2430
              		InitB1 = 70
              		InitB2 = 150
              		InitB3 = 320
      		        FinalF1 = 320
             		  FinalF2 = 900
              		FinalF3 = 2200
              		FinalB1 = 65
              		FinalB2 = 110
             		  FinalB3 = 140
                  YPos = 1-((150-y)/50)
                ElseIf y>150 And y <=200
		              InitF1 = 320
              		InitF2 = 900
              		InitF3 = 2200
              		InitB1 = 65
              		InitB2 = 110
              		InitB3 = 140
                  FinalF1 = 700
                  FinalF2 = 1220
                  FinalF3 = 2600
                  FinalB1 = 130
                  FinalB2 = 70
                  FinalB3 = 160
                  YPos = 1-((200-y)/50)
                EndIf
                
              EndIf 
                      
                        TheF1 = InitF1 + yPos*(FinalF1 - InitF1)
                        TheF2 = InitF2 + yPos*(FinalF2 - InitF2)
                        TheF3 = InitF3 + yPos*(FinalF3 - InitF3)
                        TheB1 = InitB1 + yPos*(FinalB1 - InitB1)
                        TheB2 = InitB2 + yPos*(FinalB2 - InitB2)
                        TheB3 = InitB3 + yPos*(FinalB3 - InitB3)
                        
                        CCoeff = -1 * Exp(-2 * Pi * TheB1 / SampleRate)
                        BCoeff = (2 * Exp(-1 * Pi * TheB1 / SampleRate)) * Cos(2 * Pi * TheF1 / SampleRate)
                        ACoeff = 1 - CCoeff - BCoeff
                        CCoeff2 = -1 * Exp(-2 * Pi * TheB2 / SampleRate)
                        BCoeff2 = (2 * Exp(-1 * Pi * TheB2 / SampleRate)) * Cos(2 * Pi * TheF2 / SampleRate)
                        ACoeff2 = 1 - CCoeff2 - BCoeff2
                        CCoeff3 = -1 * Exp(-2 * Pi * TheB3 / SampleRate)
                        BCoeff3 = (2 * Exp(-1 * Pi * TheB3 / SampleRate)) * Cos(2 * Pi * TheF3 / SampleRate)
                        ACoeff3 = 1 - CCoeff3 - BCoeff3 
                        
                        
                        
                        If StartDrawing(CanvasOutput(99))
                          Circle(Val(StringField(mylist(),1,";")), Val(StringField(mylist(),2,";")), 2, RGB($00,$00,$FF)) 
                          StopDrawing()
                        EndIf 
                      Else
                        MouseUpFlag = 1
                        RollOnCounter = 0
                        ChangeFreqFlag = 0
                        OldFreq = 0
                        s = 0
                      EndIf  
                 EndIf  
               Else
          took = 1      
          SetGadgetState(98,0)
          SetGadgetText(98, "play")
          
                MouseUpFlag = 1
                RollOnCounter = 0
                ChangeFreqFlag = 0
                OldFreq = 0
                s = 0
         DisableGadget(110,0)  
          
        EndIf  
     EndIf
      
   Until Event = #PB_Event_CloseWindow
   KillThread(tid_1)
    Pa_Terminate()
  EndIf
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 1
; Folding = --
; EnableThread
; EnableXP
; Executable = SAVtest_bugfixattempt4.exe